const Nodeway = require("nodeway");
const prove   = require('../prove');

class Logic extends Nodeway {
    constructor(uuid) {
        super(uuid);
    }
    async prove(proposition) {
        let step = prove(proposition);
        return new Promise(function(resolve, reject) {
            step instanceof Array ? resolve(step) : reject(new Error(step));
        });
    }
}

module.exports = Logic;
